package werte.zeichen;

import werte.Vergleichbar;

/** Klasse fr Worte
 *  @author Jrgen Giesl
 */
public class Wort implements Vergleichbar {


    private String zeichenkette;


    /** generiert eine vorgegebene Zeichenkette
     *  @param zeichenkette die vorgegebene Zeichenkette
     */
    public Wort (String zeichenkette) {
	
	this.zeichenkette = zeichenkette;

    }

        
    /** vergleicht zwei Worte, wobei Gro- und Kleinschreibung ignoriert wird
     *  @param zuvergleichen das Wort, mit dem das aktuelle Wort verglichen werden soll
     *  @return true, falls die beiden Worte bis auf Gro- und Kleinschreibung
     *   gleich sind und sonst false;
     *   falls "zuvergleichen" kein Wort ist, wird eine Fehlermeldung ausgegeben und 
     *   das Ergebnis ist ebenfalls false.
     */
    public boolean gleich (Vergleichbar zuvergleichen) {

	Wort w;

	if (zuvergleichen instanceof Wort) {
	    w = (Wort) zuvergleichen;
	    return zeichenkette.equalsIgnoreCase(w.zeichenkette);
	}
	else {
	    System.out.println ("Es wurden keine Worte verglichen.");
	    return false;
	}

    }

    public String toString () {
	
	return zeichenkette;

    }


}
